/*
   gcc -oexample3 example3.c -larguments
*/

#include <stdarg.h>
#include <syslog.h>

#include <arguments.h>

struct Argument arguments [] =
{
	{ 'l', "log",      argument_log, ARGUMENT_F_ONCE | ARGUMENT_F_PAR, {.value_log = log_callback_file} },
	{ 'p', "priority", argument_int, ARGUMENT_F_ONCE | ARGUMENT_F_PAR, {.value_int = LOG_NOTICE} },
	{ }
};

enum
{
	ARGN_LOG, ARGN_PRIO
};

#define PRIO (arguments [ARGN_PRIO].value_int)

void wlog (char const *const format, ...)
{
	va_list ap;
	va_start (ap, format);
	arguments [ARGN_LOG].value_log (PRIO, format, ap);
	va_end (ap);
}

int main (const int argc, const char **argv)
{
	int p;
	p = arguments_parse ("example3", "1.0", "[OTHER]",
		"Logging example", argc, argv, arguments);
	while (p < argc)
		wlog ("%s", argv [p ++]);
	return 0;
}
